Name: dds
Version: 3.2
Release: 2%{?dist}
Summary: The Dynamic Deployment System

License: LGPLv3
%define github github.com
%define gh_org FairRootGroup
%define gh_repo DDS
URL: http://dds.gsi.de
Source0: https://%{github}/%{gh_org}/%{gh_repo}/archive/%{version}.tar.gz
Patch0: configurable_libdir.patch
Patch1: strip_env_script.patch
Patch2: fix_install_destinations.patch
%if 0%{?suse_version} == 1500
Patch3: relax_boost_requirement.patch
%endif
%if 0%{?fedora} > 32
# https://github.com/FairRootGroup/DDS/issues/305
Patch3: fix_boost_bind_placeholders.patch
%endif

BuildRequires: boost-devel
%if 0%{?suse_version}
BuildRequires: libboost_log-devel
BuildRequires: libboost_thread-devel
BuildRequires: libboost_program_options-devel
BuildRequires: libboost_filesystem-devel
BuildRequires: libboost_system-devel
BuildRequires: libboost_regex-devel
%endif
BuildRequires: cmake
BuildRequires: gcc-c++

%if 0%{?suse_version}
%define _libexecdir %{_prefix}/libexec
%endif

%description
DDS - is a tool-set that automates and significantly simplifies a deployment of user
defined processes and their dependencies on any resource management system using a
given topology.

%global debug_package %{nil}

%prep
%autosetup -n %{gh_repo}-%{version} -p1
echo "%{version}" > version

%build
%define builddir build
cmake -S. -B%{builddir} \
      -DCMAKE_INSTALL_PREFIX=%{_prefix} \
      -DCMAKE_INSTALL_LIBDIR=%{?_lib} \
      -DCMAKE_BUILD_TYPE=Release \
      -DBUILD_dds-octopus=OFF \
      -DBUILD_dds-tutorials=OFF \
      -DBUILD_dds-test=OFF
cmake --build %{builddir} %{?_smp_mflags}
cmake --build %{builddir} --target wn_bin %{?_smp_mflags}
# TODO remove need for wn_bin target, https://github.com/FairRootGroup/DDS/issues/304

%install
DESTDIR=%{buildroot} cmake --build build --target install
# TODO install plugins to libexec
pushd %{buildroot}%{_prefix}
rm LICENSE ReleaseNotes.md
rm etc/version
popd

%files
%license LICENSE
%doc ReleaseNotes.md
%{_prefix}/etc/dds*
%{_prefix}/etc/DDS*
%{_libdir}/libdds*.so
%{_libdir}/libpipe_log_engine.so
%{_bindir}/DDS_env.sh
%{_bindir}/dds-*
%{_prefix}/plugins/*
%{_libexecdir}/dds-*
%{_datadir}/%{name}/topology.xsd
%{_bindir}/wn_bins/dds*.tar.gz


%package devel
Requires: %{name}%{?_isa} = %{version}-%{release}
Summary: Development files for dds

%description devel
This package contains the header files and CMake package for developing against DDS.

%files devel
%license LICENSE
%dir %{_includedir}/%{name}
%{_includedir}/%{name}/*.h
%{_libdir}/cmake/%{gh_repo}-%{version}/%{gh_repo}*.cmake

%changelog
* Wed Jun 10 2020 Dennis Klein <d.klein@gsi.de> - 3.2-2
- Relax Boost version requirement (to support opensuse-leap-15.2)
- Build wn_bin target
- Fix suse detection on tumbleweed
- Fix boost::placeholders import
* Tue Jun  9 2020 Dennis Klein <d.klein@gsi.de> - 3.2-1
- Package 3.2
